package com.appian.ps.plugins.sftpsmartservices.old;

import org.apache.log4j.Logger;

public class FTPConfig {

	public static final Integer SCS_ERROR=0x01;
	public static final Integer CONNECTION_ERROR = 0x02; 
	public static final Integer AUTHENTICATION_ERROR = 0x03;
	public static final Integer CERTIFICATE_ERROR = 0x04;
	public static final Integer GENERAL_ERROR = 0x05; 
	public static final Integer FILE_NOT_FOUND = 0x06; 
	public static final Integer STORE_FILE = 0x07;
	public static final Integer NON_POSITIVE_REPLY = 0x08;
	public static final Integer SOCKET_TIMEOUT = 0x09;
	
	
	private static final Logger LOG=Logger.getLogger(FTPConfig.class);
	private static final String KEY_USERNAME = "username";
	private static final String KEY_PASSWORD = "password";
	private static final String KEY_PASSPHRASE = "passphrase";
	private static final String KEY_NATPASSIVE = "natpassive"; 
	
	public static final String[] errorMessages= {"NoError", 
			"SCS.error",
			"connection.error", 
			"authentication.error",
			"cert.error",
			"general.error",
			"file.error",
			"storefile.error",
			"nonpositive.error",
			"sockettimeout.error"
	};
	
	private String serverHostname;
	private Long serverPort;
	private String username;
	private String password;
	private boolean usePerUserCredentials = false;
	private boolean natpassive = false;
	
	public String getServerHostname() {
		return serverHostname;
	}
	public void setServerHostname(String serverHostname) {
		this.serverHostname = serverHostname;
	}
	public Long getServerPort() {
		return serverPort;
	}
	public void setServerPort(Long serverPort) {
		this.serverPort = serverPort;
	}
	public String getUsername() {
		return username;
	}
	public void setUsername(String username) {
		this.username = username;
	}
	public String getPassword() {
		return password;
	}
	public void setPassword(String password) {
		this.password = password;
	} 

}
