package com.appian.ps.plugins.sftpsmartservices.old;

import org.apache.log4j.Level;
import org.apache.log4j.Logger;
import org.apache.log4j.Priority;

public class JschLogger implements com.jcraft.jsch.Logger {
	private static final Logger LOG = Logger.getLogger(SFTPConfig.class);

	@Override
	public boolean isEnabled(int level) {
		return LOG.isEnabledFor(getPriority(level));
	}

	@Override
	public void log(int level, String message) {
		LOG.log(getPriority(level), message);
	}

	private Priority getPriority(int level) {
		switch (level) {
		case DEBUG:
			return Level.TRACE;
		case ERROR:
			return Level.ERROR;
		case FATAL:
			return Level.FATAL;
		case INFO:
			// JSch sends low-level TRACE output as "INFO" level
			return Level.TRACE;
		case WARN:
			// JSch sends DEBUG output as "WARN" level
			return Level.DEBUG;
		default:
			return Level.OFF;
		}
	}
}
