package com.appian.ps.plugins.sftpsmartservices.old;

import java.util.ArrayList;
import java.util.Vector;

import org.apache.log4j.Logger;

import com.appian.ps.plugins.sftpsmartservices.GetRemoteDirectoryContentsOverSFTPBasic;
import com.appiancorp.suiteapi.common.Name;
import com.appiancorp.suiteapi.process.exceptions.SmartServiceException;
import com.appiancorp.suiteapi.process.framework.AppianSmartService;
import com.appiancorp.suiteapi.process.framework.Input;
import com.appiancorp.suiteapi.process.framework.Order;
import com.appiancorp.suiteapi.process.framework.Required;
import com.appiancorp.suiteapi.process.palette.ConnectivityServices;
import com.appiancorp.suiteapi.process.palette.PaletteInfo;
import com.jcraft.jsch.ChannelSftp;
import com.jcraft.jsch.ChannelSftp.LsEntry;
import com.jcraft.jsch.JSch;
import com.jcraft.jsch.Session;

@Deprecated
@PaletteInfo(paletteCategory="Deprecated Services", palette="Connectivity Services")
@Order({ "serverHostName", "serverPort", "sftpUsername", "sftpPassword",
		"sftpServerRemoteDirectory" })
public class RemoveDirectoryOverSFTP extends AppianSmartService {
	private static final Logger LOG = Logger
			.getLogger(GetRemoteDirectoryContentsOverSFTPBasic.class);
	private String serverHostName;
	private Long serverPort;
	private String sftpUsername;
	private String sftpPassword;
	private String sftpServerRemoteDirectory;
	JSch jsch = null;
	Session session = null;
	ChannelSftp sftpChannel = null;
	LsEntry entry = null;
	Vector<LsEntry> contents = null;
	ArrayList<String> directoryAL = null;
	ArrayList<String> fileAL = null;
	@SuppressWarnings("unchecked")
	@Override
	public void run() throws SmartServiceException {
		

		try {
			// Establish a new SFTP connection using process-specific parameters
			try {
				jsch = new JSch();
				session = jsch.getSession(sftpUsername, serverHostName);
				session.setPassword(sftpPassword);
				session.setPort(serverPort.intValue());
				session.setConfig("StrictHostKeyChecking", "no");

				// Default Configs / Supported Ciphers can be found here:
				// https://github.com/is/jsch/blob/b2ac6d9c95a688b22cbc3316ccf3315ba2fb6f86/src/com/jcraft/jsch/JSch.java
				// session.setConfig("cipher.s2c",
				// "aes128-ctr,aes128-cbc,3des-ctr,3des-cbc,blowfish-cbc,aes192-cbc,aes256-cbc,aes256-ctr");
				// session.setConfig("cipher.c2s",
				// "aes128-ctr,aes128-cbc,3des-ctr,3des-cbc,blowfish-cbc,aes192-cbc,aes256-cbc,aes256-ctr");

				session.setConfig("compression.s2c",
						"zlib,zlib@openssh.com,none");
				session.setConfig("compression.c2s",
						"zlib,zlib@openssh.com,none");

				session.connect();

				sftpChannel = (ChannelSftp) session.openChannel("sftp");
				sftpChannel.connect();
			} catch (Exception e) {
				LOG.error("Error connecting to SFTP server", e);
				throw createException(e, "error.sftp_conn", e.getMessage());
			}
			
			// Remove Directory
						if (sftpServerRemoteDirectory != null) {
							try {
								
								sftpChannel.rmdir(sftpServerRemoteDirectory);
							} catch (Exception e) {
								LOG.error("Error removing directory in remote server", e);
								throw createException(e, "error.create_folder",
										e.getMessage());
							}
						}

		} finally {
			// Close SFTP channel and session
			if (sftpChannel != null) {
				sftpChannel.disconnect();
			}
			if (session != null) {
				session.disconnect();
			}
		}

	}
	
	

	@Input(required = Required.OPTIONAL)
	@Name("serverHostName")
	public void setServerHostName(String val) {
		this.serverHostName = val;
	}

	@Input(required = Required.OPTIONAL)
	@Name("serverPort")
	public void setServerPort(Long val) {
		this.serverPort = val;
	}

	@Input(required = Required.OPTIONAL)
	@Name("sftpUsername")
	public void setSftpUsername(String val) {
		this.sftpUsername = val;
	}

	@Input(required = Required.OPTIONAL)
	@Name("sftpPassword")
	public void setSftpPassword(String val) {
		this.sftpPassword = val;
	}

	@Input(required = Required.OPTIONAL)
	@Name("sftpServerRemoteDirectory")
	public void setSftpServerRemoteDirectory(String val) {
		this.sftpServerRemoteDirectory = val;
	}

	private SmartServiceException createException(Throwable t, String key,
			Object... args) {
		return new SmartServiceException.Builder(getClass(), t).userMessage(
				key, args).build();
	}
}
